summaryrefslogtreecommitdiff
path: root/tests/misc/pwd-option
diff options
context:
space:
mode:
authorEric Blake <ebb9@byu.net>2009-03-23 14:48:19 -0600
committerEric Blake <ebb9@byu.net>2009-03-25 06:33:32 -0600
commit9b4aa5e268da5980f63a1c47c2cd7ba04ad4a394 (patch)
tree2b8b6e75d23599bd87a601fc8117284e94cf3f20 /tests/misc/pwd-option
parent53191d01e23d05f42d0d90abe07b18aae7c50b3a (diff)
downloadcoreutils-9b4aa5e268da5980f63a1c47c2cd7ba04ad4a394.tar.xz
pwd: support -L and -P
* src/pwd.c (longopts): New variable. (logical_getcwd): New function. (main): Use it. (usage): Document new options. * doc/coreutils.texi (pwd invocation): Likewise. * NEWS: Likewise. * TODO (pwd): Mark it done. * tests/misc/pwd-option: New file. * tests/Makefile.am (TESTS): Add test. * THANKS: Update. Reported by Paul D. Smith, in savannah bug 24949.
Diffstat (limited to 'tests/misc/pwd-option')
-rwxr-xr-xtests/misc/pwd-option67
1 files changed, 67 insertions, 0 deletions
diff --git a/tests/misc/pwd-option b/tests/misc/pwd-option
new file mode 100755
index 000000000..6c0242118
--- /dev/null
+++ b/tests/misc/pwd-option
@@ -0,0 +1,67 @@
+#!/bin/sh
+# Ensure that pwd options work.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ env -- pwd --version
+fi
+
+. $srcdir/test-lib.sh
+
+mkdir -p a/b || framework_failure
+ln -s a/b c || framework_failure
+base=$(env -- pwd)
+
+# Remove any logical paths from $PWD.
+cd "$base" || framework_failure
+test "x$PWD" = "x$base" || framework_failure
+
+# Enter a logical directory.
+cd c || framework_failure
+test "x$PWD" = "x$base/c" || skip_test_ "cd does not properly update \$PWD"
+
+fail=0
+env -- pwd -L > out || fail=1
+printf %s\\n "$base/c" > exp || fail=1
+
+env -- pwd --logical -P >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- pwd --physical >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+# By default, we use -P unless POSIXLY_CORRECT.
+env -- pwd >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- POSIXLY_CORRECT=1 pwd >> out || fail=1
+printf %s\\n "$base/c" >> exp || fail=1
+
+# Make sure we reject bogus values, and silently fall back to -P.
+env -- PWD="$PWD/." pwd -L >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- PWD=bogus pwd -L >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- PWD="$base/a/../c" pwd -L >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+compare out exp || fail=1
+
+Exit $fail